Attribute VB_Name = "nMail"
Option Explicit

Public Const INVALID_SOCKET = -1

Public Const NMAIL_ATTACHMENT_TEMP_SIZE = 400

Public Const NMAIL_ERROR_SOCKET = -1
Public Const NMAIL_ERROR_AUTHENTICATE = -2
Public Const NMAIL_ERROR_INVALID_NO = -3
Public Const NMAIL_ERROR_TIMEOUT = -4
Public Const NMAIL_ERROR_FILE_OPEN = -5
Public Const NMAIL_ERROR_PARTIAL = -6
Public Const NMAIL_ERROR = -10

Public Const NMAIL_ERROR_SUSPEND_ATTACHMENT_FILE = -20

Public Const NMAIL_ERROR_SERVICE_NOT_AVAILABLE = -421
Public Const NMAIL_ERROR_MAILBOX_UNAVAILABLE = -450
Public Const NMAIL_ERROR_LOCAL_ERROR = -451
Public Const NMAIL_ERROR_INSUFFICIENT_SYSTEM_STORAGE = -452
Public Const NMAIL_ERROR_SYNTAX_ERROR = -500
Public Const NMAIL_ERROR_PARAMETER = -501
Public Const NMAIL_ERROR_COMMAND_NOT_IMPLEMENTED = -502
Public Const NMAIL_ERROR_BAD_SEQUENCE = -503
Public Const NMAIL_ERROR_USER_UNKOWN = -550
Public Const NMAIL_ERROR_USER_NOT_LOCAL = -551
Public Const NMAIL_ERROR_EXCEEDED_STORAGE_ALLOCATION = -552
Public Const NMAIL_ERROR_MAILBOX_NAME_NOT_ALLOWED = -553
Public Const NMAIL_ERROR_RELAY_OPERATION_REJECTED = -553
Public Const NMAIL_ERROR_TRANSACTION_FAILED = -554

Public Const NMAIL_NO_ATTACHMENT_FILE = -1
Public Const NMAIL_ATTACHMENT_FILE = 0

Public Const NMAIL_SUCCESS = 1

Public Const NMAIL_ADD_DATE_FIELD = 1
Public Const NMAIL_ADD_MESSAGEID_FIELD = 2
Public Const NMAIL_SUSPEND_ATTACHMENT_FILE = 4
Public Const NMAIL_SUSPEND_NEXT = 8

Public Const NMAIL_PARTIAL_ATTACHMENT_FILE = 1
Public Const NMAIL_GET_TEXT_ONLY = 2

Public Const NMAIL_OPTION_TIMEOUT = 0
Public Const NMAIL_OPTION_HEADER_MAX = 1
Public Const NMAIL_OPTION_BODY_MAX = 2
Public Const NMAIL_OPTION_ALREADY_FILE = 3
Public Const NMAIL_OPTION_DEBUG_MODE = 3
Public Const NMAIL_OPTION_CONNECT_TIMEOUT = 5
Public Const NMAIL_OPTION_SPLIT_CHAR = 6
Public Const NMAIL_OPTION_SUSPEND_SIZE = 7

Public Const NMAIL_FILE_OVERWRITE = 0
Public Const NMAIL_FILE_RENAME = 1
Public Const NMAIL_FILE_ALREADY_ERROR = 2

Public Const NMAIL_GET_ERROR_MESSAGE = 0
Public Const NMAIL_GET_DEBUG_MESSAGE = 1

Public Const NMAIL_DEBUG_START = 1
Public Const NMAIL_DEBUG_END = 0

Public Const NMAIL_GET_UIDL_ALL = 0

Public Const NMAIL_CONNECT_TIMEOUT_ON = 0
Public Const NMAIL_CONNECT_TIMEOUT_OFF = 1

Public Const NMAIL_SMTP_AUTH_NOT_USE = 0
Public Const NMAIL_SMTP_AUTH_PLAIN = 1
Public Const NMAIL_SMTP_AUTH_LOGIN = 2
Public Const NMAIL_SMTP_AUTH_CRAM_MD5 = 4

Public Declare Function NMailGetVersion Lib "nMail" () As Long
Public Declare Function NMailInitializeWinSock Lib "nMail" () As Long
Public Declare Function NMailEndWinSock Lib "nMail" () As Long
Public Declare Function NMailPop3Connect Lib "nMail" (ByVal HostName As String) As Long
Public Declare Function NMailPop3ConnectPortNo Lib "nMail" (ByVal HostName As String, ByVal no As Long) As Long
Public Declare Function NMailPop3Authenticate Lib "nMail" (ByVal s As Long, ByVal Id As String, ByVal Password As String, ByVal ApopFlag As Boolean) As Long
Public Declare Function NMailPop3Close Lib "nMail" (ByVal s As Long) As Long
Public Declare Function NMailPop3GetMailSize Lib "nMail" (ByVal s As Long, ByVal no As Long) As Long
Public Declare Function NMailPop3DeleteMail Lib "nMail" (ByVal s As Long, ByVal no As Long) As Long
Public Declare Function NMailPop3GetMailStatus Lib "nMail" (ByVal s As Long, ByVal no As Long, ByVal subject As String, ByVal dateStr As String, ByVal from As String, ByVal header As String, ByVal SizeFlag As Long) As Long
Public Declare Function NMailPop3GetMail Lib "nMail" (ByVal s As Long, ByVal no As Long, ByVal subject As String, ByVal dateStr As String, ByVal from As String, ByVal header As String, ByVal body As String, ByVal Path As String, ByVal filename As String) As Long
Public Declare Function NMailPop3GetMailEx Lib "nMail" (ByVal s As Long, ByVal no As Long, ByVal subject As String, ByVal dateStr As String, ByVal from As String, ByVal header As String, ByVal body As String, ByVal Path As String, ByVal filename As String, ByVal temp As String, ByVal Flag As Long) As Long
Public Declare Function NMailPop3GetMailPartial Lib "nMail" (ByVal s As Long, ByVal no As Long, ByVal subject As String, ByVal dateStr As String, ByVal from As String, ByVal header As String, ByVal body As String, ByVal Path As String, ByVal filename As String) As Long
Public Declare Function NMailPop3GetUidl Lib "nMail" (ByVal s As Long, ByVal no As Long, ByVal Uidl As String, ByVal Max As Long) As Long
Public Declare Function NMailPop3GetAttachmentFileStatus Lib "nMail" (ByVal s As Long, ByVal no As Long, ByVal Id As String, ByVal Max As Long) As Long
Public Declare Function NMailSmtpSendMail Lib "nMail" (ByVal HostName As String, ByVal ToStr As String, ByVal Cc As String, ByVal Bcc As String, ByVal from As String, ByVal subject As String, ByVal body As String, ByVal header As String, ByVal Path As String, ByVal Flag As Long) As Long
Public Declare Function NMailSmtpSendMailPortNo Lib "nMail" (ByVal HostName As String, ByVal ToStr As String, ByVal Cc As String, ByVal Bcc As String, ByVal from As String, ByVal subject As String, ByVal body As String, ByVal header As String, ByVal Path As String, ByVal Flag As Long, ByVal PortNo As Long) As Long
Public Declare Function NMailSmtpConnect Lib "nMail" (ByVal HostName As String) As Long
Public Declare Function NMailSmtpConnectPortNo Lib "nMail" (ByVal HostName As String, ByVal no As Long) As Long
Public Declare Function NMailSmtpAuthenticate Lib "nMail" (ByVal s As Long, ByVal HostName As String, ByVal Id As String, ByVal Password As String, ByVal AuthMode As Long) As Long
Public Declare Function NMailSmtpSendMailEx Lib "nMail" (ByVal s As Long, ByVal ToStr As String, ByVal Cc As String, ByVal Bcc As String, ByVal from As String, ByVal subject As String, ByVal body As String, ByVal header As String, ByVal Path As String, ByVal temp As String, ByVal Flag As Long) As Long
Public Declare Function NMailSmtpClose Lib "nMail" (ByVal s As Long) As Long
Public Declare Function NMailGetHeaderField Lib "nMail" (ByVal Field As String, ByVal header As String, ByVal name As String, ByVal Size As Long) As Long
Public Declare Function NMailAttachmentFileFirst Lib "nMail" (ByVal temp As String, ByVal subject As String, ByVal dateStr As String, ByVal from As String, ByVal header As String, ByVal body As String, ByVal Path As String, ByVal filename As String, ByVal FirstHeader As String, ByVal FirstBody As String) As Long
Public Declare Function NMailAttachmentFileNextVB Lib "nMail" (ByVal temp As String, ByVal subject As String, ByVal dateStr As String, ByVal from As String, ByVal header As String, ByVal body As String, ByVal Path As String, ByVal filename As String, ByVal NextHeader As String, ByVal NextBody As String) As Long
Public Declare Function NMailAttachmentFileNext Lib "nMail" (ByVal temp As String, ByVal header As String, ByVal body As String, ByVal NextHeader As String, ByVal NextBody As String) As Long
Public Declare Function NMailAttachmentFileClose Lib "nMail" (ByVal temp As String) As Long
Public Declare Function NMailAttachmentFileStatus Lib "nMail" (ByVal header As String, ByVal Id As String, ByVal Max As Long) As Long
Public Declare Function NMailSetOption Lib "nMail" (ByVal Opt As Long, ByVal Value As Long) As Long
Public Declare Function NMailGetOption Lib "nMail" (ByVal Opt As Long) As Long
Public Declare Function NMailGetSuspendNumber Lib "nMail" (ByVal Path As String) As Long
Public Declare Sub NMailGetMessage Lib "nMail" (ByVal Mtype As Long, ByVal Message As String, Max As Long)
Public Declare Sub NMailSetParameter Lib "nMail" (ByVal TimeOutSec As Long, ByVal HeaderMax As Long, ByVal BodyMax As Long)

Public Function NMailGetString(Src As String) As String
    If InStr(Src, Chr(0)) > 0 Then
        NMailGetString = Left(Src, InStr(Src, Chr(0)) - 1)
    Else
        NMailGetString = Src
    End If
End Function
